#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vs1000.h>
#include <audio.h>
#include <mappertiny.h>
#include <minifat.h>
#include <codec.h>
#include <vsNand.h>
#include <player.h>
#include <usblowlib.h>

#include <dev1000.h>
extern struct FsNandPhys fsNandPhys;
extern struct FsPhysical *ph;
extern struct FsMapper *map;
extern struct Codec *cod;
extern struct CodecServices cs;
extern u_int16 codecVorbis[];

#define BOOKMARKS

#include "bookvars.h"
struct screen {
    u_int16 X, Y, invertMask; /* do not change fields, used in asm funcs! */
} screen;

struct MENU {
    u_int16 curEntry;
    u_int16 level;
    u_int32 currentSector;
    u_int16 marked;
    u_int16 tree[8];
    u_int16 buffer[256];
} menu;

//u_int16 menuBuffer[256];
//u_int32 menuCurrentSector;
//u_int32 menuStart; /* menu file must be unfragmented! */
//u_int32 menuSize;
//u_int16 curEntry = 0;
//u_int16 menuTree[8], menuLevel = 0;
u_int16 parentName[42/2];
u_int16 playingParentName[42/2];

volatile u_int16 locked = 0, menuMode = 1, playerMode = 0;
const struct MENUENTRY *entry = NULL;
u_int16 playingEntryNumber;
struct MENUENTRY playingEntry;
const struct KeyMapping *oldKeyMap;
u_int32 backLightTime;

#if 1
/*Keymaps are actually loaded by init.c */
#define playModeMap ((const struct KeyMapping *)&USB.pkt.payload[132])
#define menuModeMap (((const struct KeyMapping *)&USB.pkt.payload[132])+16)
#define lockedModeMap (((const struct KeyMapping *)&USB.pkt.payload[132])+32)
#else
const struct KeyMapping playModeMap[] = {
  {KEY_POWER, ke_pauseToggle},
  {KEY_LONG_PRESS|KEY_POWER, ke_stop},
  {KEY_1, ke_volumeDown},
  {KEY_LONG_PRESS|KEY_1, ke_volumeDown},
  {KEY_2, ke_volumeUp},
  {KEY_LONG_PRESS|KEY_2, ke_volumeUp},
  {KEY_3, ke_previous},
  {KEY_LONG_PRESS|KEY_3, ke_rewind},
  {KEY_4, ke_next},
  {KEY_LONG_PRESS|KEY_4, ke_ff_faster},
  {KEY_LONG_PRESS|KEY_RELEASED, ke_ff_off},
  {KEY_5, ke_earSpeaker},
  {KEY_LONG_PRESS|KEY_5, (s_int16)(ke_menu|KEY_LONG_ONESHOT)},
#if 1
  {KEY_6, ke_bookmark},
  {KEY_LONG_PRESS|KEY_6, (s_int16)(ke_hold|KEY_LONG_ONESHOT)},
#endif
  {0, ke_null}
};
const struct KeyMapping menuModeMap[] = {
  {KEY_POWER, (int)ke_play},
  {KEY_LONG_PRESS|KEY_POWER, (int)ke_powerOff},
  {KEY_1, (int)ke_down},
  {KEY_LONG_PRESS|KEY_1, (int)ke_down},
  {KEY_2, (int)ke_up},
  {KEY_LONG_PRESS|KEY_2, (int)ke_up},
  {KEY_3, (int)ke_parent},
  {KEY_LONG_PRESS|KEY_3, (int)(ke_parent|KEY_LONG_ONESHOT)},
  {KEY_4, (int)ke_select},
  {KEY_LONG_PRESS|KEY_4, (int)(ke_select|KEY_LONG_ONESHOT)},
  {KEY_5, (int)ke_select/*(int)ke_earSpeaker*/},
  {KEY_LONG_PRESS|KEY_5, (int)(ke_return|KEY_LONG_ONESHOT)},
#if 1
  {KEY_6, ke_bookmark},
  {KEY_LONG_PRESS|KEY_6, (int)(ke_hold|KEY_LONG_ONESHOT)},
#endif
  {0, ke_null}
};
const struct KeyMapping lockedModeMap[] = {
  //{KEY_LONG_PRESS|KEY_POWER, (int)ke_powerOff},
#if 1
  {KEY_LONG_PRESS|KEY_6, (s_int16)(ke_hold|KEY_LONG_ONESHOT)},
#endif
  {0, ke_null}
};
#endif

/*
  BUG/FEATURE?:

  More memory:
  0x10..0x1f (emulator area) and 0x40..0x4f (reserved for hooks) are not used
 */

#define WAKE_WITH_KEY_6 /*pause wakes up with KEY_6 also*/

//#define USE_DEBUG
#define DISPLAY
#define BATTERY_LEVEL (1<<6) /*GPIO0 pin*/
//#define AUTO_POWEROFF //disabled to allow easier USB-programming


#ifdef DISPLAY
/* Do not change prototypes, functions are used in bookasm.s */
auto void ScreenInit(void); /*39 words*/
void ScreenClear(void); /*29 words*/
void ScreenLocate(register __b0 int x, register __b1 int y); /*34 words*/
void ScreenPutData(register __a1 u_int16 c); /*36 words*/
void ScreenPutChar(register __c0 u_int16 c); /*58 words*/
auto void ScreenPutPackedX(register __i1 const u_int16 *d,
			   register __c0 u_int16 maxWords,
			   register __c1 u_int16 xEnd); /*54 words*/
auto void ScreenPutGfx(register __i1 const u_int16 *d,
		       register __c0 u_int16 words); /*29 words*/



#include <romfont.h>

#define SCREEN_SET_COMMAND_MODE PERIP(GPIO1_CLEAR_MASK) = 0x0004
#define SCREEN_SET_DATA_MODE    PERIP(GPIO1_SET_MASK) = 0x0004
#define SCREEN_SELECT   PERIP(GPIO0_CLEAR_MASK) = 0x4000 //CS2
#define SCREEN_END      PERIP(GPIO0_SET_MASK) = 0x4000 //CS2

#define WRHI PERIP(GPIO0_SET_MASK) = GPIO0_WR
#define WRLO PERIP(GPIO0_CLEAR_MASK) = GPIO0_WR


// Set x,y pointer of display controller
#if 1
void ScreenLocate(register __b0 int x, register __b1 int y);
#else
void ScreenLocate(register __b0 int x, register __b1 int y) { /*34 words*/
  SCREEN_SELECT; //CS low
#ifdef PARALLEL_DISPLAY /*Note: must be defined in Makefile to be seen by asm*/
  NandPutCommand((screen.Y = y) | 0xb0);
  NandPutCommand((screen.X = x) & 0x0f);
  NandPutCommand((x >> 4) | 0x0010);
#else
  SCREEN_SET_COMMAND_MODE;
  SpiSendReceive((screen.Y = y) | 0xb0);
  SpiSendReceive((screen.X = x) & 0x0f);
  SpiSendReceive((x >> 4) | 0x0010);
#endif
  SCREEN_END;
}
#endif

#if 1
void ScreenPutData(register __a1 u_int16 c);
#else
// Write image data octet to display controller
void ScreenPutData(register __a1 u_int16 c) { /*36 words*/
  SCREEN_SELECT; //CS low
#ifdef PARALLEL_DISPLAY /*Note: must be defined in Makefile to be seen by asm*/
  NandPutAddressOctet(c ^ screen.invertMask);
#else
  SCREEN_SET_DATA_MODE;
  SpiSendReceive(c ^ screen.invertMask);
#endif
  SCREEN_END; //CS high
  if (++screen.X >= 132) {
    ScreenLocate(0, ++screen.Y);
  }
}
#endif

// Draw character c to screen using custom data output function
// This function is responsible for character mapping.
void ScreenPutChar(register __c0 u_int16 c) { /*58 words*/
  register u_int16 length;
  register u_int16 bit_index;
  register const u_int16 *p;

  if (c == 0)
      return;
#if 0
  if (c < 32 || c > 210) { //Invalid char
    return;
  }
#endif
  if (c > 132) { //Fixed width charset
    length = 5;    
    bit_index = 8;
    p = &fontData[5*(c-133)];
  } else { //variable width charset ("normal" ascii)
    // ASCII ' ' (32 decimal) is in ROM index 0
    length = fontPtrs[c-31] - fontPtrs[c-32];
    bit_index = 0;
    p = &fontData[fontPtrs[c-32]];
  }
#if 0
  /* prevent wrap in the middle of character */
  if (screen.X + length > 132) {
    ScreenLocate(0, ++screen.Y);
  }
#endif
  {
      register u_int16 i;
      for (i=0; i<length; i++) {
	  ScreenPutData((s_int16)(*p++) >> bit_index);
      }
  }  
  ScreenPutData(0);
}

#if 1
void ScreenPutNum(register __c1 u_int16 c);
#else
void ScreenPutNum(register __c1 u_int16 c) { /*27 words*/
    ScreenPutChar(c/10 +SYMBOL_DIGIT);
    ScreenPutChar(c%10 +SYMBOL_DIGIT);
}
#endif

// Put packed string in X ram
auto void ScreenPutPackedX(register __i1 const u_int16 *p,
			   register __c0 u_int16 maxWords,
			   register __c1 u_int16 xEnd) { /*54 words*/
    register int i;
    for (i=0; i<maxWords; i++) {
	register u_int16 c = *p++;
	register u_int16 d = ((s_int16)c>>8) & 255;
	if (d == 0)
	    break;
	ScreenPutChar(d);
	c &= 255;
//	if (c == 0)
//	    break;
	ScreenPutChar(c);
    }
    i = screen.X;
    for (; i < xEnd; i++)
	ScreenPutData(0);
}

#if 1
auto void ScreenPutGfx(register __i1 const u_int16 *d,
		       register __c0 u_int16 words);
#else
auto void ScreenPutGfx(register __i1 const u_int16 *d,
		       register __c0 u_int16 words) { /*29 words*/
    register int i;
    for (i=0;i<words;i++) {
	ScreenPutData((s_int16)*d>>8);
	ScreenPutData(*d++);
    }
}
#endif

// Screen Clear
#if 1
void ScreenClear(void);
#else
void ScreenClear(void) { /*29 words*/
    register u_int16 i;
    ScreenLocate(0, 0);
    for (i=0;i<8*132;i++)
	ScreenPutData(0); /*ScreenPutData() handles the line wraps*/
    ScreenLocate(0, 0);
}
#endif

/* can be "auto" because we do not return */
auto void MyPowerOff(void) { /*13 words*/
    //RealPowerOff();
    while (1) {
	ph->Read(ph, 4096/512, 4096/512, mallocAreaX, NULL);
	BootFromX(mallocAreaX);
	//((struct FsNandPhys *)ph)->waitns += 20;
    }
}

#endif/*DISPLAY*/



#ifdef BATTERY_LEVEL
/* Now self-contained, can be loaded on-demand.. */
u_int16 CheckBatteryLevel(void) { /*65 words*/
    register u_int16 i;
    register u_int16 mode = PERIP(GPIO0_MODE);

    PERIP(GPIO0_MODE) = mode & ~BATTERY_LEVEL;
    PowerSetVoltages(&voltages[voltCoreUser]);

    /* Wait a bit... about 200us */
    for (i=0;i<30000;i++)
	PERIP(GPIO0_IDATA);

    if ((PERIP(GPIO0_IDATA) & BATTERY_LEVEL)) {
	/*VBATT > VREF(=0.36*AVDD)
	  Raise VREF and try again. */
	i = voltages[voltAnaUser];
	if (voltages[voltAnaUser] < 31)
	    voltages[voltAnaUser]++;
    } else {
	/*VBATT < VREF(=0.36*AVDD) */
	if (voltages[voltAnaUser] > 12)
	    voltages[voltAnaUser]--;
	i = voltages[voltAnaUser];
    }
    PERIP(GPIO0_MODE) = mode;
    /* This is not strictly needed.. */
    PowerSetVoltages(&voltages[voltCorePlayer]);
    return i;
}
#endif/*BATTERY_LEVEL*/


const void *MenuGetEntry(register __c0 u_int16 entry) {/*45 words*/
    register u_int32 wordPos = (u_int32)entry * 32; /* 64 bytes per entry */
    u_int32 sector = (wordPos >> 8) + menuStart;
#if 0
    puthex(wordPos);
    puts("=pos");
#endif
    if (sector != menu.currentSector) {
	menu.currentSector = sector;
	ReadDiskSector(menu.buffer, sector);
    }
    return (void *)(menu.buffer + (wordPos & 255));
}

#define MENU_LINES 6
#define MENU_TOP_LINE 2
const struct MENUENTRY *MenuPaintEntry(u_int16 cur) {/*137 words*/
    const struct MENUENTRY *m;
    register u_int16 i, start = cur+1;
//    PERIP(GPIO1_ODATA) &= ~LED1;
    ScreenLocate(0, 0);
    if (parentName[0]) {
	ScreenPutPackedX(parentName, 42/2, 132);
	//ScreenLocate(0, 1);
	screen.invertMask = 0x0a;
	ScreenPutPackedX("\p", 0, 132);
	screen.invertMask = 0;
    } else {
	ScreenPutGfx(USB.pkt.payload, 132/2);
	ScreenLocate(0, 1);
	ScreenPutGfx(USB.pkt.payload+132/2, 132/2);
    }

    for (i=0; i < (MENU_LINES+1)/2 ; i++) {
	m = (struct MENUENTRY *)MenuGetEntry(--start);
	if ((m->flags & MFLG_FIRST))
	    break;
    }
#if 0
    if ( !(m->flags & MFLG_FIRST)) {
	ScreenPutGfx("\xe070\x3870\xe000\x0000", 4);
    }
#endif

    for (i=0; i < MENU_LINES; ) {
	register int flags;
	m = (struct MENUENTRY *)MenuGetEntry(start+i);
	flags = m->flags;
#ifdef BOOKMARKS
	if (m->subtree == NULL && m->fileName[0] == (':'<<8)
	    && m->fileName[1] >= settings.numBookMarks) {
	    break;
	}
#endif
	//ScreenLocate(0, i+MENU_TOP_LINE);
	if (start+i == cur)
	    screen.invertMask = 0xff; /* invert the selected entry */
	/* Invert the whole line */
#ifdef BOOKMARKS
	/* For bookmarks use the name of the entry the bookmark points to. */
	if (m->fileName[0] == (':'<<8) && !m->subtree) {
	    m = (struct MENUENTRY *)
		MenuGetEntry(settings.bookMarks[m->fileName[1]]);
	}
#endif
	ScreenPutPackedX(&m->name[0], 42/2, 132);
#if 1
	if (m->fileName[0] == ('!'<<8) && m->subtree) {
	    ScreenLocate(100, i+MENU_TOP_LINE);
	    if ((s_int16)settings.backLightTime == -1) {
		ScreenPutPackedX("\p+++", 1, 132);
	    } else {
		ScreenPutNum(settings.backLightTime/TIMER_TICKS);
		ScreenPutPackedX("\ps ", 1, 132);
	    }
	}
#endif
	screen.invertMask = 0;
	i++;
	if ((flags & MFLG_LAST)) {
	    break;
	}
    }
    for (; i < MENU_LINES; i++) {
	//ScreenLocate(0, i+(MENU_TOP_LINE+1));
	ScreenPutPackedX("\p", 0, 132);
    }
    return (struct MENUENTRY *)MenuGetEntry(cur);
}

#ifdef BATTERY_LEVEL
#if 1
void DisplayBatteryLevel(void);
#else
void DisplayBatteryLevel(void) { /*61 words*/
    /* Battery level */
    ScreenLocate(101, 0);
    ScreenPutData(0xff);
    ScreenPutData(0x81);
    screen.invertMask = 0xbd;
    ScreenPutPackedX("", 0, (100-12)+battery.level);
    screen.invertMask = 0x81;
    ScreenPutPackedX("", 0, (100-12)+32);
    screen.invertMask = 0x00;
    ScreenPutGfx("\xff24\x3c00", 2);
    if (locked) {
	ScreenPutGfx("\x384e\x89a9\x894e\x3800", 4);
    } else {
	ScreenPutPackedX("", 0, 132);
    }
}
#endif
#endif

#ifdef BOOKMARKS
const u_int16 markedGfx[3][5] = {
    {0x0000,0x0000,0x0000,0x0000,0x0000},
    {0x7f7e,0x0c18,0x0c7e,0x7f00,0x0000},
    {0x7f49,0x4936,0x007f,0x4949,0x4100}
};
#endif

void PlayerDisplay(void) { /*268 words*/ /* does not clear it */
//    PERIP(GPIO1_ODATA) |= LED1;
#if 1
    /* when we play/ff, check when we have played the current entry */
    if (cs.playTimeSeconds > (playingEntry.end>>16)) {
	/* search for the entry.. */
	register const struct MENUENTRY *m =MenuGetEntry(playingEntryNumber+1);
	if (!memcmp(m->fileName, playingEntry.fileName, 4) &&
	    cs.playTimeSeconds >= (m->start>>16)
	    /*&& cs.playTimeSeconds <= (m->end>>16)*/) {
	    playingEntryNumber++;
	    goto skipped;
	}
    }
#endif
#if 1
    /* when we rewind, check when we have gone past the current entry */
    if (cs.playTimeSeconds < (playingEntry.start>>16)) {
	/* search for the entry.. */
	register const struct MENUENTRY *m =MenuGetEntry(playingEntryNumber-1);
	if (!memcmp(m->fileName, playingEntry.fileName, 4) &&
	    /*cs.playTimeSeconds >= (m->start>>16) &&*/
	    cs.playTimeSeconds <= (m->end>>16)) {
	    playingEntryNumber--;
	skipped:
	    memcpy(&playingEntry, m, sizeof(playingEntry));
#ifdef BOOKMARKS
	    menu.marked = 0;
#endif
	}
    }
#endif

    ScreenLocate(42, 0);
    ScreenPutChar(player.pauseOn ? SYMBOL_PAUSE : SYMBOL_PLAY);
#ifdef BOOKMARKS
    ScreenPutGfx(markedGfx[menu.marked], 5);
#endif
#if 1
    /* earspeaker */
    ScreenPutPackedX(earSpeakerReg ? "\p3D" : "\p ", 1, 68);
#endif

#if 1 /* 61 words! playing time -- not required.
	 TODO: needs hours too! (use 32-bit division) */
    {
	register u_int32 t = cs.playTimeSeconds;
	register u_int16 h = t / 3600;
	ScreenLocate(0, 0);
#if 0
	ScreenPutNum(h);
#else
	ScreenPutChar(h%10 +SYMBOL_DIGIT);
#endif
	t -= (u_int32)h * 3600;
	ScreenPutChar(':');
	h = (u_int16)t / 60;
	ScreenPutNum(h);
	ScreenPutChar(':');
	ScreenPutNum((u_int16)t % 60);
    }
#endif

#if 1 /* volume */
    ScreenLocate(70, 0);
    ScreenPutChar(SYMBOL_RIGHTSPK);
    {
	register int len = 12-(24 + player.volume)/4; /* 0..xx */
	if (len > 0) {
	    ScreenPutGfx("\x8000\xc000\xe000\xf000\xf800\xfc00\xfe00\xff80"
			 "\xffc0\xffe0\xfff0\xfff8\xfffc\xfffe\xffff\xffff",
			 len);
	}
	ScreenPutPackedX("\p", 0, 69+31);
    }
#endif
    ScreenLocate(0, 1);
    if (playingParentName[0]) {
	ScreenPutPackedX(playingParentName, 42/2, 132);
	//ScreenLocate(0, 2);
	screen.invertMask = 0x0a;
	ScreenPutPackedX("\p", 0, 132);
	screen.invertMask = 0;
    } else {
	ScreenPutGfx(USB.pkt.payload, 132/2);
	ScreenLocate(0, 2);
	ScreenPutGfx(USB.pkt.payload+132/2, 132/2);
    }
    ScreenLocate(0, 4);
    ScreenPutPackedX(&playingEntry.name[0], 42/2, 132);
}

void MyKeyEventHandler(enum keyEvent event) { /*140 words*/
    register __i3 const struct MENUENTRY *rentry = entry;
    /* separate the small-numbered cases */
    if (event == ke_previous) {
	if ((playingEntry.flags & MFLG_FIRST)) {
	    /* first entry*/
	} else {
	    /* search for the entry.. */
	    register const struct MENUENTRY *m =
		 MenuGetEntry(playingEntryNumber-1);
	    if (!memcmp(m->fileName, playingEntry.fileName, 4)) {
		playingEntryNumber--;
		memcpy(&playingEntry, m, sizeof(playingEntry));
#ifdef BOOKMARKS
		menu.marked = 0;
#endif
	    }
	}
	/*TODO: go to the previous entry! */
	//cs.goTo = playingEntry.start>>16;
	PlayRangeSet(playingEntry.start, 0x7fffffffUL);
	goto out;
    } else if (event == ke_next) {
	PlayRangeSet(playingEntry.end, 0x7fffffffUL); /*clears "marked" */
	goto out;
    }

    switch ((int)event) {
#ifdef BOOKMARKS
    case ke_bookmark:
	/* if in bookmark menu, remove bookmark,
	   if in play mode, add bookmark. */
	if (menuMode) {
	    if (rentry->fileName[0] == (':'<<8) && settings.numBookMarks) {
		/* remove bookmark */
		register int i = rentry->fileName[1];
		settings.numBookMarks--;
		memcpyYY(settings.bookMarks+i, settings.bookMarks+i+1,
			 settings.numBookMarks-i);
		if (settings.numBookMarks == 0) {
		    /* No bookmarks left, return to main menu */
		    menu.level = menu.curEntry = 0;
		} else if (i) {
		    menu.curEntry--;
		}
		goto paint;
	    }
	} else if (//!menu.marked &&
		   settings.numBookMarks < sizeof(settings.bookMarks)) {
#if 1
	    register int i;
	    register __y u_int16 *p = settings.bookMarks;
	    for (i=0;i<settings.numBookMarks;i++)
		if (*p++ == playingEntryNumber)
		    break;
	    if (p[-1] == playingEntryNumber) {
		/* bookmark to this entry already exists */
		menu.marked = 2;
	    } else
#endif
	    {
		settings.bookMarks[settings.numBookMarks++] =
		    playingEntryNumber;
		menu.marked = 1;
	    }
	}
	//PERIP(GPIO1_ODATA) ^= LED2; /* used for backlight? */
	break;
#endif

#if 0
    case ke_earSpeaker:
	bassReg ^= 0x8400;
	SetVolume();
	break;
#endif

    case ke_hold:
	/* toggle keymaps.. */
	if (locked ^= 1) {
	    oldKeyMap = currentKeyMap;
	    currentKeyMap = lockedModeMap;
	} else {
	    currentKeyMap = oldKeyMap;
	}
#ifdef BATTERY_LEVEL
	DisplayBatteryLevel();
#endif
	break;

    case ke_menu:
	menuMode = 1;
	currentKeyMap = menuModeMap;
	break;

    case ke_return:
    ret:
        if (playerMode)
	    goto backToPlayer;
	break;
    
    case ke_play:
	if (rentry->fileName[0] == ('!'<<8)) {
	    if (rentry->subtree)
		break;
	    settings.backLightTime = rentry->fileName[1];
//ScreenPutChar('B');
	    goto parent;
	}
#ifdef BOOKMARKS
	if (rentry->fileName[0] == (':'<<8)) {
	    /* bookmark */
	    if (settings.numBookMarks == 0)
		break;
	    menu.tree[menu.level++] = menu.curEntry;
	    menu.curEntry = settings.bookMarks[rentry->fileName[1]];
	    entry = rentry = (struct MENUENTRY *)MenuGetEntry(menu.curEntry);
	    //TODO: find the parent of the bookmarked entry
	    memcpy(parentName, rentry->name, sizeof(parentName));
	}
#endif
	if (rentry->fileName[0]) {
	    cs.cancel = 1;
	    player.pauseOn = 0;
	    playerMode = -1; /* cancel current and start new file */
	    playingEntryNumber = menu.curEntry;
	backToPlayer:
	    menuMode = 0;
	    currentKeyMap = playModeMap;
	    ScreenClear();
	    //PlayerDisplay();
	}
	break;

    case ke_select:
	if (rentry->subtree) {
#ifdef BOOKMARKS
	    if (settings.numBookMarks == 0 && rentry->fileName[0] == (':'<<8))
		break;
#endif
	    menu.tree[menu.level++] = menu.curEntry;
	    menu.curEntry = rentry->subtree;
	    memcpy(parentName, rentry->name, sizeof(parentName));
	    goto paint;//entry = MenuPaintEntry(menu.curEntry);
	}
#if 0 /* allow browsing of bookmarks */
	/* must be after entry->subtree, because bookmark-menu allows
	   direct playing of the first bookmark entry by the "play" button. */
	if (rentry->fileName[0] == (':'<<8)) {
	    /* bookmark */
	    menu.tree[menu.level++] = menu.curEntry;
	    menu.curEntry = settings.bookMarks[rentry->fileName[1]];
	    goto paint;//entry = MenuPaintEntry(menu.curEntry);
	}
#endif
	if (/*rentry->subtree == NULL &&*/
	    rentry->fileName[0] == ('!'<<8)) {
	    settings.backLightTime = rentry->fileName[1];
	    goto parent;
	}
	break;

    case ke_parent:
    parent:
        if (menu.level == 0)
	    goto ret;
	menu.curEntry = menu.tree[--menu.level];

	if (menu.level) {
	    const struct MENUENTRY *m =
		m = (struct MENUENTRY *)MenuGetEntry(menu.tree[menu.level-1]);
	    memcpy(parentName, m->name, sizeof(parentName));
	} else {
	    parentName[0] = 0;
	}
	goto paint;//entry = MenuPaintEntry(menu.curEntry);

    case ke_up:
	if (!(rentry->flags & MFLG_FIRST)) {
	    menu.curEntry--;
	    goto paint;//entry = MenuPaintEntry(menu.curEntry);
	}
	break;

    case ke_down:
	if ((rentry->flags & MFLG_LAST)
#ifdef BOOKMARKS
	    || (rentry->subtree == NULL &&
		rentry->fileName[0] == (':'<<8) &&
		rentry->fileName[1]+1 >= settings.numBookMarks)
#endif
	    ) {
	    /* last entry, can not go forward */
	} else {
	    menu.curEntry++;
	paint:
	    entry = rentry = MenuPaintEntry(menu.curEntry);
#ifdef BATTERY_LEVEL
	    DisplayBatteryLevel();
#endif
	}
	break;

    case ke_stop:
	keyOldTime = -32768;
	event = ke_previous; /* cancel playback */
	/* fall through */
    default:
	/* execute the default actions */
	RealKeyEventHandler(event);
	break;
    }

out:
    if (settings.backLightTime) {
#ifdef PARALLEL_DISPLAY
	PERIP(GPIO1_ODATA) |= LED2;
#else
	PERIP(GPIO1_MODE) &= ~(1<<4); /*TX low = LED on*/
#endif
	backLightTime = timeCount;
#ifdef WAKE_WITH_KEY_6
	SetHookFunction((u_int16)USBSuspend, NullHook); /* disable suspend */
#endif
    } else {
#ifdef PARALLEL_DISPLAY
	PERIP(GPIO1_ODATA) &= ~LED2;
#else
	PERIP(GPIO1_MODE) |= (1<<4); /*TX high*/
#endif
    }
}

void MyUserInterfaceIdleHook(void) { /*94 words*/
    if (uiTrigger) {
	uiTrigger = 0;

	if (menuMode == 1) {
	    menuMode++;
	    ScreenClear();
	    entry = MenuPaintEntry(menu.curEntry);
#ifdef BATTERY_LEVEL
	    DisplayBatteryLevel();
#endif
	    if (locked) {
		oldKeyMap = menuModeMap;
		currentKeyMap = lockedModeMap;
	    } else {
		currentKeyMap = menuModeMap;
	    }
	} else if (menuMode == 0 && playerMode) {
	    PERIP(SCI_STATUS) &= ~(SCISTF_ANADRV_PDOWN|SCISTF_ANA_PDOWN);
	    PlayerDisplay();
	}
#ifdef BATTERY_LEVEL
	if (timeCount - battery.checkTime > TIMER_TICKS) {
	    battery.checkTime = timeCount;
	    battery.level = CheckBatteryLevel();
	    LoadCheck(NULL, 0);
	    if (!menuMode) {
		DisplayBatteryLevel();
	    }
#ifdef AUTO_POWEROFF
	    if (battery.level <= 14) {
		PowerOff();
	    }
#endif
	}
#endif
#if 0
	UserInterfaceIdleHook();
#else
	NandPutCommand(0); /*Bring data bus low*/
	KeyScan7();
	//KeyScan();
#endif
	if (settings.backLightTime != 0xffffU &&
	    timeCount - backLightTime > settings.backLightTime) {
#ifdef PARALLEL_DISPLAY
	    PERIP(GPIO1_ODATA) &= ~LED2;
#else
	    PERIP(GPIO1_MODE) |= (1<<4); /*TX high*/
#endif
	    backLightTime = timeCount;
#ifdef WAKE_WITH_KEY_6
	    SetHookFunction((u_int16)USBSuspend, Suspend7); /*enable suspend*/
#endif
	}
    }
}


void main(void) { /*264 words*/
    parentName[0] = 0;

    memset(&menu, 0, sizeof(menu));
    menu.currentSector = -1;
#ifdef BATTERY_LEVEL
    /* already done at init -- structure at the same address?? */
    {
	register int i;
	for (i=0;i<24;i++) {
	    battery.level = CheckBatteryLevel();
	}
    }
#endif

#ifdef DISPLAY
    memset(&screen, 0, sizeof(screen));
    SetHookFunction((u_int16)PowerOff, MyPowerOff);
#endif
    SetHookFunction((u_int16)KeyEventHandler, MyKeyEventHandler);
    SetHookFunction((u_int16)IdleHook, MyUserInterfaceIdleHook);
    backLightTime = timeCount;
    SetHookFunction((u_int16)USBSuspend, NullHook); /* disable */

    currentKeyMap = menuModeMap;
    while (1) {
	if (menuMode) {
	    player.pauseOn = 1; /* enters low-power pause as needed */
#ifdef WAKE_WITH_KEY_6
	    memset(tmpBuf, 0, sizeof(tmpBuf));
	    cs.Output(&cs, tmpBuf, 2);
#else
	    while (player.pauseOn) {
		memset(tmpBuf, 0, sizeof(tmpBuf));
		AudioOutputSamples(tmpBuf, 2);//sizeof(tmpBuf)/2);
	    }
#endif
	} else {
	    int pmode;
	    __y int pnum;
	selectedNew:
	    memcpy(playingParentName, parentName, sizeof(playingParentName));
	    memcpy(&playingEntry, entry, sizeof(playingEntry));
	    pnum = menu.curEntry;
	selectedNext:
	    pmode = playingEntry.flags;
	    PlayRangeSet(playingEntry.start,
			 (playingEntry.flags & MFLG_USEENDTIME) ?
			 playingEntry.end : 0x7fffffffUL);

	    /* Recurse until lowest level found */
	    while (playingEntry.subtree) {
		register struct MENUENTRY *m;
		memcpy(playingParentName, playingEntry.name,
		       sizeof(playingParentName));
	    cont:
		playingEntryNumber = playingEntry.subtree;
		m = (struct MENUENTRY *)MenuGetEntry(playingEntryNumber);
		memcpy(&playingEntry, m, sizeof(playingEntry));
	    }
	    PERIP(SCI_STATUS) &= ~(SCISTF_ANADRV_PDOWN|SCISTF_ANA_PDOWN);
	    if (OpenFileBaseName(playingEntry.fileName) != 0xffffU) {
		playerMode = 1;
#ifdef BOOKMARKS
		menu.marked = 0;
#endif
		if (!(pmode & MFLG_USEENDTIME)) {
		    PlayRangeSet(playingEntry.start,
				 (playingEntry.flags & MFLG_USEENDTIME) ?
				 playingEntry.end : 0x7fffffffUL);
		}

		PlayRange();
		if (playerMode == -1)
		    goto selectedNew;

		if (cs.fileLeft < 5 &&
		    !(playingEntry.flags & MFLG_ENDPLAY)) {
		    /* Continue playing another file. */
		    /* We can overwrite the subtree field because it is a copy,
		       not the original. */
		    playingEntry.subtree = playingEntryNumber+1;
		    goto cont;
		}
		if ((pmode & MFLG_USEENDTIME) && !(pmode & MFLG_LAST)) {
		    register struct MENUENTRY *m;
		    playingEntryNumber = ++pnum;
		    m = (struct MENUENTRY *)MenuGetEntry(playingEntryNumber);
		    memcpy(&playingEntry, m, sizeof(playingEntry));
		    goto selectedNext;
		}

	    } else {
		//puts("File not found");
	    }
	    //SetRate(1200U); /*longer low-power wait than with 44100Hz*/
	    playerMode = 0;
	    menuMode = 1;
	}
    }
}
