#ifndef __BOOKVARS_H__
#define __BOOKVARS_H__
#include <vstypes.h>

#ifdef MAPPERLESS
#define MAX_BADS 127
#endif

#ifdef ASM

#else

#ifdef MAPPERLESS
extern s_int16 numOfBads;
extern u_int32 bads[MAX_BADS];
#endif

extern struct screen {
    u_int16 X, Y, invertMask;
} screen;

extern struct {
    u_int16 level;
    u_int32 checkTime;
} battery;

/*
  Note: the parent field is no longer used.
  20080123: name and fileName fields swapped to save code space (20 words!)
 */
struct MENUENTRY {
    u_int16 parent;        /*0 parent index:  0 or 1..65535 */
    u_int16 subtree;       /*1 subtree index: 0 or 1..65535 */
#define MFLG_LAST       1
#define MFLG_FIRST      2
#define MFLG_USEENDTIME 4
#define MFLG_ENDPLAY    8 /* end of leaf entries, stop playing */
    u_int16 flags;         /*2 misc flags */
    u_int16 fileName[8/2]; /*3 FAT short filename, .ogg implied */
    u_int32 start;         /* x/65536 seconds */
    u_int32 end;           /* x/65536 seconds */
    u_int16 name[42/2];    /* entry name (for display) */
    /*
      fileName can also begin with ':' to mark special functions
      like the bookmark menu. '!' marks backlight timer.
      Or with zero to mark submenu without playable file.
     */
};

extern u_int16 menuBuffer[256];
extern u_int32 menuCurrentSector;
extern u_int32 menuStart; /* menu file must be unfragmented! */
extern u_int16 menuTree[4], menuLevel;
extern u_int16 parentName[42/2];
extern u_int16 playingParentName[42/2];
extern u_int16 bookMarks[32];
extern u_int16 numBookMarks;

extern volatile u_int16 locked, menuMode, playerMode;
extern u_int16 curEntry;
extern const struct MENUENTRY *entry;
extern u_int16 playingEntryNumber;
extern struct MENUENTRY playingEntry;
extern const struct KeyMapping *oldKeyMap;


enum keyEvent2 {
    ke_select = 64, /* subdir */
    ke_parent,      /* parent dir */
    ke_down,        /* down the list */
    ke_up,          /* up the list */
    ke_play,
    ke_menu,
    ke_return,      /* return to play mode from menu */
    ke_bookmark,    /* set or delete bookmark */
    ke_hold,        /* set or release hold */
    ke_stop,
};



extern const struct KeyMapping playModeMap[];
extern const struct KeyMapping menuModeMap[];
extern const struct KeyMapping lockedModeMap[];



struct Settings {
    s_int16 numBookMarks;  /* 0xffff = unused entry */
    u_int16 backLightTime; /* 0 = always off, 65535 = always on */
    s_int16 volume;
    u_int16 bookMarks[28]; /* original GoBible supports 24 bookmarks */
    u_int16 check;     /* checksum */
};
//extern __y struct Settings settings;
extern __y u_int16 z[18], bassG[6];//, btmp[64];
extern __y struct Settings btmp;
#define settings btmp //(*((__y struct Settings *)&btmp))
//#define menuStart trebleIdx //USB.totbytes //trebleIdx
#define menuStart USB.totbytes //trebleIdx
#endif

#endif /*__BOOKVARS_H__*/
