#include <stdio.h>
#include <stdlib.h>
#include <string.h>


unsigned char pic[64][132] = {{0}};

int main(int argc, char *argv[]) {
    unsigned char *a, *buffer, apu[2*100];
    int i, x, y, error = 0, width, height, w, h, maxval;
    int inf=0, ouf=0;
    FILE *handle;
    int pics = 1;

    for(i=1;i<argc;i++) {
	if(argv[i][0]=='-') {
	    x = 1;
	    while(argv[i][x]) {
		switch(argv[i][x]) {
		case '2':
		    pics = 2;
		    break;
		default:
		    break;
		}
		x++;
	    }
	} else if(!inf) {
	    inf = i;
	} else if(!ouf) {
	    ouf = i;
	} else {
	    fprintf(stderr, "Too many filenames!\n");
	    fprintf(stderr, "Usage: %s [-<options>] [ppmfile [gfxfile]]\n",argv[0]);
	    exit(10);
	}
    }

    if(!ouf)
	fprintf(stderr, "Outputting to stdout\n");
    if(!inf)
	fprintf(stderr, "Reading from stdin\n");

    if (!inf || (handle=fopen(argv[inf], "rb"))) {
	if(!inf) {
	    handle = stdin;
	} else {
	    fprintf(stderr, "%s:\n", argv[inf]);
	}

	fgets((char *)apu, 100, handle);
	if (!strncmp((char *)apu, "P6", 2)) {
	    do {
		fgets(apu, 100, handle);
	    } while (apu[0] == '#');
	    width = atoi((char *)apu);
	    i=0;
	    while(apu[i]!=' ' && apu[i]!='\t' && apu[i])
		i++;
	    height = atoi((char *)apu+i);
	    fgets((char *)apu, 100, handle);    /* just get the maxval..*/
	    maxval = atoi((char *)apu);

	    fprintf(stderr, "Picture is %d x %d (maxval=%d)\n", width, height, maxval);

	    if ((buffer = calloc(3*width*height, 1))) {
		if(fread(buffer, 3*width*height, 1, handle) != 1)
		    fprintf(stderr,"Short file! Result may be quite original..\n");
		if(inf)
		    fclose(handle);

		if (maxval != 255) {
		    for(i=3*width*height-1;i>=0;i--) {
			buffer[i] = buffer[i]*255/maxval;
		    }
		}
		if ((width>132 || height>64))
		    fprintf(stderr, "Output picture will be sized 100 x 160\n");
		w = width;
		h = height;
		if (w > 132)
		    w = 132;
		if (h > 64)
		    h = 64;

		for (y=0;y<h;y++) {
		    a = buffer+3*width*y;
		    for(x=0;x<w;x++) {
			//printf("%d %d %d", a[0], a[1], a[2]);
			pic[y][x] = (a[0] | a[1] | a[2]);
			a += 3;
		    }
		}
		free(buffer);

		{
		    int i;
		    FILE *fp = ouf ? fopen(argv[ouf], "wb") : stdout;
		    for (i=0;i<pics;i++) {
			int limit = i ? 250 : 80;
			for (y=0;y<64;y+=8) {
			    for (x=0;x<132;x++) {
				int b;
				unsigned char t = 0;
				for (b=0;b<8;b++) {
				    if (pic[y+b][x] < limit)
					t |= (1<<b);
				}
				if (fp == stdout) {
				    if (x & 1) {
					printf("%02x,", t);
					if (x==131)
					    printf("\n");
				    } else {
					printf("0x%02x", t);
				    }
				} else {
				    fputc(t, fp);
				}
			    }
			}
		    }
		    if (fp != stdout)
			fclose(fp);
		}

		exit(error);
	    } else {
		fprintf(stderr, "Memory allocation error (%d bytes)\n", 3*width*height);
		if(inf)
		    fclose(handle);
		exit(42);
	    }
	} else {
	    fprintf(stderr, "Don't know how to handle this type of ppm: %s\n", apu);
	    if(inf)
		fclose(handle);
	    exit(24);
	}
    } else {
	fprintf(stderr, "Could not access %s\n", argv[inf]);
	exit(10);
    }
    return 0;
}



